#include "rtpreceiver.h"

rtpReceiver::rtpReceiver(QObject *parent) :
    QThread(parent)
{
	int jittcomp=40;
	bool_t adapt=TRUE;

	ortp_init();
	ortp_scheduler_init();
	ortp_set_log_level_mask(ORTP_DEBUG|ORTP_MESSAGE|ORTP_WARNING|ORTP_ERROR);
	session=rtp_session_new(RTP_SESSION_RECVONLY);
	rtp_session_set_scheduling_mode(session,1);
	rtp_session_set_blocking_mode(session,1);
	rtp_session_set_local_addr(session,"0.0.0.0",61610);
	rtp_session_set_connected_mode(session,TRUE);
	rtp_session_set_symmetric_rtp(session,TRUE);
	rtp_session_enable_adaptive_jitter_compensation(session,adapt);
	rtp_session_set_jitter_compensation(session,jittcomp);
	rtp_session_set_payload_type(session,0);
	rtp_session_signal_connect(session,"ssrc_changed",(RtpCallback)rtp_session_reset,0);
}

rtpReceiver::~rtpReceiver()
{
	rtp_session_destroy(session);
	ortp_exit();
	ortp_global_stats_display();
}

void rtpReceiver::run()
{

	unsigned char buffer[160];
	int have_more;
	int err;
	uint32_t ts=0;
	int stream_received=0;

	while(1) {
		have_more=1;
		while (have_more){
			err=rtp_session_recv_with_ts(session, buffer, 160, ts, &have_more);
			if (err>0) stream_received=1;
			if ((stream_received) && (err>0)) {
				emit recvData((const char*)buffer, 160);
			}
		}
		ts+=160;
	}
}
